//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  nb`uV̈ꗗ`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1119 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  protected
    procedure Paint; override;
  public
    FFrontColor : Cardinal;
    FBackColor  : Cardinal;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    ColorDialog1: TColorDialog;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  HatchBrush';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 35;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;

    FFrontColor := aclBlack;
    FBackColor  := aclWhite;
  end;
end;

//=============================================================================
//  OiFύXĂ݂
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color := ARGBToColorRef(MyPanel.FFrontColor);
  if ColorDialog1.Execute then begin
    MyPanel.FFrontColor := ColorRefToARGB(ColorDialog1.Color);
  end;
  MyPanel.Invalidate;
end;

//=============================================================================
//  wiFύXĂ݂
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  ColorDialog1.Color := ARGBToColorRef(MyPanel.FBackColor);
  if ColorDialog1.Execute then begin
    MyPanel.FBackColor := ColorRefToARGB(ColorDialog1.Color);
  end;
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//  nb`uV̈ꗗ`
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphic  : TGPGraphics;
  LHBStyleMax : Integer;
  LHBStyle    : HatchStyle;
  LHBBrush    : TGPHatchBrush;
  LCount      : Integer;
  LLoopX      : Integer;
  LLoopY      : Integer;
  LGPRect     : TGPRect;
begin
  inherited;

  //TGPGraphicsIuWFNg𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //HatchStyle̐DS53
  LHBStyleMax := Integer(HatchStyleTotal);

  LCount := 0;
  for LLoopY := 0 to LHBStyleMax div 6 do begin
    for LLoopX := 0 to 6 do begin
       //X^C擾(GDIPAPI.pasɒ`)
       LHBStyle := HatchStyle(LCount);
       //TGPHatchBrushIuWFNg𐶐
       LHBBrush := TGPHatchBrush.Create(LHBStyle, FFrontColor, FBackColor);
       //`̈̎w
       LGPRect  := MakeRect(LLoopX * 80 + 10, LLoopY * 50 + 10, 70, 40);
       //̃uVŎlp``
       LGPGraphic.FillRectangle(LHBBrush, LGPRect);
       //TGPHatchBrushj
       LHBBrush.Free;
       if LCount >= LHBStyleMax then break;
       inc(LCount);
    end;
    if LCount >= LHBStyleMax then break;
  end;

  //CreateIuWFNg͉
  LGPGraphic.Free;
end;

end.
