//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  }`̕`ɕKv GDI+ ֌WTv
//
//  pXō\̊euV̓KpTv
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1119 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  private
    FStartColor    : TGPColor;
    FEndColor      : TGPColor;
    FFrontColor    : TGPColor;
    FBackColor     : TGPColor;
    FBrushColor    : TGPColor;
    FLineColor     : TGPColor;
    FLineWidth     : integer;
    FImageFilePath : String;
    FText          : String;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    property StartColor    : TGPColor read FStartColor    write FStartColor;
    property EndColor      : TGPColor read FEndColor      write FEndColor;
    property FrontColor    : TGPColor read FFrontColor    write FFrontColor;
    property BackColor     : TGPColor read FBackColor     write FBackColor;
    property BrushColor    : TGPColor read FBrushColor    write FBrushColor;
    property LineColor     : TGPColor read FLineColor     write FLineColor;
    property LineWidth     : Integer  read FLineWidth     write FLineWidth;
    property ImageFilePath : String   read FImageFilePath write FImageFilePath;
    property Text          : String   read FText          write FText;
  end;

  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+ pX̃uV';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 90;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;
  end;

  //MyPanel̊evpeB̐ݒ
  MyPanel.ImageFilePath := '033609.jpg';
  MyPanel.Text          := 'Delphi';

  RadioGroup1.Caption := '';
  RadioGroup1.Items.Add('TGPSolidBrush');
  RadioGroup1.Items.Add('TGPHatchBrush');
  RadioGroup1.Items.Add('TGPTextureBrush');
  RadioGroup1.Items.Add('TGPLinearGradientBrush');

  RadioGroup1.ItemIndex := 0;
end;

//=============================================================================
//  [JnF]{^
//  RadioGroup1̑Iڂɂă^CgƐFς悤ɂĂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then begin
    case RadioGroup1.ItemIndex of
      0: MyPanel.BrushColor := ColorRefToARGB(ColorDialog1.Color);
      1: MyPanel.FrontColor := ColorRefToARGB(ColorDialog1.Color);
      3: MyPanel.StartColor := ColorRefToARGB(ColorDialog1.Color);
    end;
  end;
  MyPanel.Invalidate;
end;

//=============================================================================
//  [IF]{^
//  RadioGroup1̑Iڂɂă^CgƐFς悤ɂĂ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  if ColorDialog1.Execute then begin
    case RadioGroup1.ItemIndex of
      0: MyPanel.LineColor := ColorRefToARGB(ColorDialog1.Color);
      1: MyPanel.BackColor := ColorRefToARGB(ColorDialog1.Color);
      3: MyPanel.EndColor  := ColorRefToARGB(ColorDialog1.Color);
    end;
  end;
  MyPanel.Invalidate;
end;

//=============================================================================
//  RadioGroup1OnClickCx
//  RadioGroup1̑Iڂɂă{^̃eLXgƐFύX
//=============================================================================
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  Button1.Enabled := True;
  Button2.Enabled := True;

  case RadioGroup1.ItemIndex of
    0:
    begin
      Button1.Caption := '̐F ';
      Button2.Caption := '֊s̐F ';
    end;
    1:
    begin
      Button1.Caption := 'OXF ';
      Button2.Caption := 'wiF ';
    end;
    2:
    begin
      Button1.Caption := ' ';
      Button2.Caption := '';
      Button1.Enabled := False;
      Button2.Enabled := False;
    end;
    3:
    begin
      Button1.Caption := 'JnF ';
      Button2.Caption := 'IF ';
    end;
  end;
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanel̃RXgN^
//  ̃NX̃vpeB́C̃NXŏ̂CpI
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  FStartColor := aclRed;
  FEndColor   := aclYellow;
  FFrontColor := aclSilver;
  FBackColor  := aclRed;
  FBrushColor := aclRed;
  FLineColor  := aclBlack;
  FLineWidth  := 2;
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphicg   : TGPGraphics;
  LGPPath       : TGPGraphicsPath;
  LGPImag       : TGPImage;
  LGPBrush      : TGPBrush;
  LGPFontFamily : TGPFontFamily;
  LGPStrFormat  : TGPStringFormat;
  LGPPen        : TGPPen;
  LGPRect       : TGPRectF;
begin
  inherited;

  //TGPGraphicsPath̃IuWFNg𐶐
  LGPGraphicg := TGPGraphics.Create(Canvas.Handle);
  //TGPTextureBrushŎgp摜̎w
  LGPImag := TGPImage.Create(FImageFilePath);


  //oX̃IuWFNg𐶐
  LGPPath := TGPGraphicsPath.Create();

  //TGPFontFamilyTGPStringFormat̃IuWFNg𐶐邪Cɐݒ͂Ȃ
  //ftHĝ܂܎gp
  LGPFontFamily := TGPFontFamily.Create('Arial Black');
  LGPStrFormat  := TGPStringFormat.Create;

  //oXɕǉ
  LGPPath.AddString(FText,              //`悷镶
                   Length(FText),      //̒
                   LGPFontFamily,       //tHg̎
                   FontStyleBold,      //tHg̃X^C
                   80,                 //tHg̃TCY
                   MakePoint(5.0,5.0), //`Jnʒu(`̈w肢֐)
                   LGPStrFormat);       //ɕ`̃ACg̐ݒ

  //oX̗֊s`ỹIuWFNg𐶐
  LGPPen := TGPPen.Create(FLineColor, FLineWidth);
  //̕`̈擾
  //ۂɂ̓pX̍E㉺[l̍WlD̗̈uV̓Kp͈͂Ƃ
  LGPPath.GetBounds(LGPRect);

  //RadioGroup1Item̒lɉāCYBrushIuWFNg𐶐
  LGPBrush := nil;
  case Form1.RadioGroup1.ItemIndex of
    0: LGPBrush := TGPSolidBrush.Create(FBrushColor);
    1: LGPBrush := TGPHatchBrush.Create(HatchStyleDarkDownwardDiagonal,
                                       FFrontColor,
                                       FBackColor);
    2: LGPBrush := TGPTextureBrush.Create(LGPImag);
    3: LGPBrush := TGPLinearGradientBrush.Create(LGPRect, FStartColor, FEndColor, 0);
  end;

  //pX̓hׂė֊s`
  LGPGraphicg.FillPath(LGPBrush, LGPPath);
  LGPGraphicg.DrawPath(LGPPen, LGPPath);

  //CreateIuWFNg͉
  LGPBrush.Free;
  LGPPen.Free;
  LGPImag.Free;
  LGPStrFormat.Free;
  LGPFontFamily.Free;
  LGPPath.Free;
  LGPGraphicg.Free;
end;

end.
