//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  eNX`uV
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1119 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, ExtDlgs;

type
  TMyPanel = class(TPanel)
  protected
    procedure Paint; override;
  end;

  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel       : TMyPanel;
    FImageFilePath : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  TypInfo;

{$R *.DFM}

//=============================================================================
//  tH[̏
//  GetEnumName,TypeInfo̎gpɂ́CusesTypInfoKv
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  Caption := 'GDI+  TextureBrush';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 105;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;
  end;

  FImageFilePath := ExtractFilePath(Application.ExeName) + '046641.gif';
  //TWrapMode̒l擾RadioGroup1ɒ`̕Zbg
  for i := 0 to 4 do begin
    RadioGroup1.Items.Add(GetEnumName(TypeInfo(TWrapMode), i));
  end;
  RadioGroup1.ItemIndex := 0;
end;

//=============================================================================
//  [t@C]{^
//  wỉ摜ύXꍇ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenPictureDialog1.InitialDir = '' then begin
    OpenPictureDialog1.InitialDir := ExtractFileDir(Application.ExeName);
  end;
  OpenPictureDialog1.Filter := '摜t@C(*.png;*.jpg;*.jpeg;*.bmp|' +
                               '*.png;*.jpg;*.jpeg;*.bmp';

  if OpenPictureDialog1.Execute then begin
    FImageFilePath := OpenPictureDialog1.FileName;
    OpenPictureDialog1.InitialDir := ExtractFileDir(FImageFilePath);
    MyPanel.Invalidate;
  end;
end;

//=============================================================================
//  RadioGroup1OnClickCxg
//  ύXMyPanelĕ`
//=============================================================================
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphicg : TGPGraphics;
  LGPRect     : TGPRect;
  LGPImg      : TGPImage;
  LGPTBrush   : TGPTextureBrush;
begin
  inherited;

  //TGPGrahics̃IuWFNg𐶐
  LGPGraphicg := TGPGraphics.Create(Canvas.Handle);
  //`̈w
  LGPRect := MakeRect(ClientRect);

  //wiɕ\摜pɁCTGPImageIuWFNg𐶐
  LGPImg    := TGPImage.Create(Form1.FImageFilePath);
  //摜TGPTextuerBrushɎw肷
  LGPTBrush := TGPTextureBrush.Create(LGPImg);

  //摜̔zuԂw
  LGPTBrush.SetWrapMode(TWrapMode(Form1.RadioGroup1.ItemIndex));
  //lp``Cw肵uVœhׂ
  LGPGraphicg.FillRectangle(LGPTBrush, LGPRect);

  //CreateIuWFNg͉
  LGPImg.Free;
  LGPTBrush.Free;
  LGPGraphicg.Free;
end;

end.
