//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜̕ˏOf[V\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0127 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, GDIPOBJ, GDIPAPI;

type
  TForm1 = class(TForm)
    Button1: TButton;
    TrackBar1: TTrackBar;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  OnCreateCxg
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;

  with TrackBar1 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Min          := 0;
    Max          := 100;
    Position     := 0;
  end;
end;

//=============================================================================
//  [Button1]NbNCxg
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  //摜t@Cǂݍ
  FImageFilePath := '';
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  end;

  OpenDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;';
  if OpenDialog1.Execute then begin
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;
    Invalidate;
  end;
end;

//=============================================================================
//  TrackBar1OnChangeCxg
//=============================================================================
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Invalidate;
end;

//=============================================================================
//  OnPaintCxg
//  摜̕ˏOf[V\
//=============================================================================
procedure TForm1.FormPaint(Sender: TObject);
var
  LGDPImage         : TGPImage;
  LGDPGraphic       : TGPGraphics;
  LGDPDrawRect      : TGPRect;
  LGDPPathGradBrush : TGPPathGradientBrush;
  LGDPPath          : TGPGraphicsPath;
  LSurroundCount    : Integer;
  LGDPColorSurround : TGPColor;
  LFocusScale       : Single;
begin
  if FImageFilePath = '' then exit;

  //`̋`̈̐ݒ
  LGDPDrawRect := MakeRect(20, 50, ClientWidth - 40, ClientHeight - 70);

  //TGPGraphics̃CX^X𐶐āCwi𔒂œhׂ
  LGDPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGDPGraphic.Clear(aclWhite);

  //ȉ~̃pX𐶐āC`ȉ~ŃNbv
  LGDPPath := TGPGraphicsPath.Create;
  LGDPPath.AddEllipse(LGDPDrawRect);
  LGDPGraphic.SetClip(LGDPPath);

  //摜t@CTGPImagẽCX^X𐶐ĕ`
  LGDPImage   := TGPImage.Create(FImageFilePath);
  LGDPGraphic.DrawImage(LGDPImage, LGDPDrawRect);


  //pXOf[ṼCX^X𐶐āCS̐Fw
  //{Tvł́CS̐F̃At@l0
  //ӂɂCxႭȂ(At@lɂOf[VKp̂)
  //F̎w MakeColor(A, R, G, B) ł\
  LGDPPathGradBrush := TGPPathGradientBrush.Create(LGDPPath);
  LGDPPathGradBrush.SetCenterColor(aclWhite and $00FFFFFF);

  //ӂ̐F̐ݒ
  LSurroundCount    := 1;
  LGDPColorSurround := aclWhite;
  LGDPPathGradBrush.SetSurroundColors(@LGDPColorSurround, LSurroundCount);

  //Of[V̊Jnʒu
  LFocusScale := TrackBar1.Position / 100;
  LGDPPathGradBrush.SetFocusScales(LFocusScale, LFocusScale);

  //ȉ~w̃uVœhׂ
  LGDPGraphic.FillEllipse(LGDPPathGradBrush, LGDPDrawRect);

  LGDPPath.Free;
  LGDPImage.Free;
  LGDPGraphic.Free;
end;

//=============================================================================
//  OnResizeCxg
//=============================================================================
procedure TForm1.FormResize(Sender: TObject);
begin
  Invalidate;
end;

end.

